Attribute VB_Name = "UpdateFiles"
Option Explicit

Private Const TIME_DIF_SEC As Double = 5
Private Const TIME_DIF As Double = 1 / 24 / 3600 * TIME_DIF_SEC

Private Const ALL_FILES As Integer = vbSystem + vbHidden + vbDirectory

Public IsCanceled As Boolean

Public Sub UpdateFilesInSubFolders(ByVal strPathOrigin As String, _
                                    ByVal strPathCopy As String, _
                                    objCallBackTarget As Object)
    
    Dim colSubFolders As New Collection
    Dim I As Long
    
    strPathOrigin = AddBackSlash(strPathOrigin)
    strPathCopy = AddBackSlash(strPathCopy)
    
    UpdateFilesInOneFolder strPathOrigin, strPathCopy, _
                            colSubFolders, objCallBackTarget
    
    If IsCanceled Then Exit Sub
    
    For I = 1 To colSubFolders.Count
        If Dir(strPathCopy & colSubFolders(I), ALL_FILES) = "" Then
'           Debug.Print "[Make]" & AddBackSlash(strPathCopy & vntSubFolder)
            If Not (objCallBackTarget Is Nothing) Then _
                objCallBackTarget.FileOp "[Make]" _
                                        & AddBackSlash(strPathCopy & colSubFolders(I))
            MkDir (strPathCopy & colSubFolders(I))
        Else
            If Not (objCallBackTarget Is Nothing) Then _
                objCallBackTarget.FileOp "[Chck]" _
                                        & AddBackSlash(strPathCopy & colSubFolders(I))
        End If
        UpdateFilesInSubFolders strPathOrigin & colSubFolders(I), _
                                    strPathCopy & colSubFolders(I), objCallBackTarget
        If IsCanceled Then Exit Sub
    Next

    Set colSubFolders = Nothing

End Sub

Public Sub UpdateFilesInOneFolder(ByVal strPathOrigin As String, _
                                    ByVal strPathCopy As String, _
                                    colSubFolders As Collection, _
                                    objCallBackTarget As Object)
    
    Dim intAttr As Integer, strPath As String
    Dim colFiles As New Collection
    
    Dim strFullPathOrigin As String
    Dim strFullPathCopy As String
    
    Dim I As Long
    
    strPathOrigin = AddBackSlash(strPathOrigin)
    strPathCopy = AddBackSlash(strPathCopy)
    
    'Scan the Folder and Get Subfolder and File Names
    strPath = Dir(strPathOrigin, ALL_FILES)
    Do Until strPath = ""
        If IsCanceled Then Exit Sub
        Select Case strPath
            Case ".", ".."  'Myself and Parent Folder
            Case Else       'File or Folder
                
                On Error GoTo InSystemUse
                intAttr = GetAttr(strPathOrigin & strPath)
                On Error GoTo 0
                
                If (intAttr And vbDirectory) = vbDirectory Then
                    'Subfolders
                    colSubFolders.Add strPath
                Else
                    'Files
                    colFiles.Add strPath
                End If
        
        End Select
        strPath = Dir()
    Loop

    'Copy Mssing Files or Newer Files
    For I = 1 To colFiles.Count
        If IsCanceled Then Exit Sub
        
        strFullPathOrigin = strPathOrigin & colFiles(I)
        strFullPathCopy = strPathCopy & colFiles(I)
        
        'Missing File
        If Dir(strFullPathCopy, ALL_FILES) = "" Then
            If Not (objCallBackTarget Is Nothing) Then _
                objCallBackTarget.FileOp "[Copy]" _
                                        & strFullPathCopy
            FileCopy strFullPathOrigin, strFullPathCopy
        'File with Newer Time Stamp
        ElseIf CDbl(FileDateTime(strFullPathOrigin)) _
                - CDbl(FileDateTime(strFullPathCopy)) _
                > TIME_DIF Then
            If Not (objCallBackTarget Is Nothing) Then _
                objCallBackTarget.FileOp "[Copy]" _
                                        & strFullPathCopy
            FileCopy strFullPathOrigin, strFullPathCopy
        Else
            If Not (objCallBackTarget Is Nothing) Then _
                objCallBackTarget.FileOp "[Pass]" _
                                        & strFullPathCopy
        
        End If
    Next
    
    Exit Sub

'Error Handler
InSystemUse:
    intAttr = vbSystem
    Resume Next

End Sub

Private Function AddBackSlash(ByVal strPath As String) As String
    If Right(strPath, 1) <> "\" Then
        AddBackSlash = strPath & "\"
    Else
        AddBackSlash = strPath
    End If
End Function






